class Counter3 implements Runnable {

    private int currentValue;

    public Counter3(String threadName) {
        currentValue = 0;
    }

    public int getValue() { return currentValue; }

    public void run() {                          // (3) Thread entry point
        try {
            while (currentValue < 5) {
                System.out.println(Thread.currentThread() + ": " + (currentValue++));
                Thread.sleep(250);               // (4) Current thread sleeps.
            }
        } catch (InterruptedException e) {
            System.out.println(Thread.currentThread() + " interrupted.");
        }
        System.out.println("Exit from thread: " + Thread.currentThread());
    }
}
